(* あるふぁ変換というか
   他のことにも流用してますが *)

open Id
open ILang

let g_id x = { x with id = Shared.new_int () }

let rec g env e =
  let find x =
    match x with
    | Var v -> (try M.find v env with Not_found -> x)
    | _ -> x
  in
  let add_list xs ys env = List.fold_left2
    (fun env x y -> M.add x (Var y) env)
    env xs ys
  in
  match e with
  | V x -> V(find x)
  | Op(x, ys) -> Op(find x, List.map find ys)
  | If(c,x,y,e1,e2) -> If(c, find x, find y, g env e1, g env e2)
  | Let(x, e1, e2) ->
      let x_ = g_id x in
      let env_ = M.add x (Var x_) env in
      Let(x_, g env e1, g env_ e2)
  | LetRec(f, xs, e1, e2) ->
      let f_ = g_id f in
      let xs_ = List.map g_id xs in
      let env2 = M.add f (Var f_) env in
      let env1 = add_list xs xs_ env2 in
      LetRec(f_, xs_, g env1 e1, g env2 e2)
  | Loop(x, ys, zs, e) ->
      let x_ = g_id x in
      let ys_ = List.map g_id ys in
      let env_ = add_list ys ys_ (M.add x (Var x_) env) in
      Loop(x_, ys_, List.map find zs, g env_ e)

let f e = g M.empty e
