(* 定数伝播その2 *)
(* 部分冗長性除去でMovが生じるので *)

open TreeAsm

let find x env = try M2.find x env with Not_found -> x

let rec g env e =
  match e with
  | Ret exp -> Ret(g1 env exp)
  | Let(x, Mov y, e) when not (is_reg x) && not (is_reg y) ->
      g (M2.add x (find y env) env) e
  | Let(x,exp,e) -> Let(x, g1 env exp, g env e)
and g1 env exp =
  match exp with
  | Nop | Rd | Imm _ -> exp
  | If(c,x,y,e1,e2) -> If(c, find x env, find y env, g env e1, g env e2)
  | IfI(c,x,i,e1,e2) -> IfI(c, find x env, i, g env e1, g env e2)
  | FIf(c,x,y,e1,e2) -> FIf(c, find x env, find y env, g env e1, g env e2)
  | St(x,y,i) -> St(find x env, find y env, i)
  | Op2(o,x,y) -> Op2(o, find x env, find y env)
  | Op1i(o,x,i) -> Op1i(o, find x env, i)
  | Op1(o,x) -> Op1(o, find x env)
  | Call(l, xs) -> Call(l, List.map (fun x -> find x env) xs)
  | Mov x -> Mov(find x env)
  | Save(x,y) -> Save(find x env, find y env)
  | Restore x -> Restore(find x env)

let f xs = List.map
    (fun x -> { x with body = g M2.empty x.body })
    xs
