(* 可能なら内部自由変数を外部自由変数にする *)

open Shared
open Id
open ILang
open Global

let is_const = function Var _ -> false | _ -> true

let rec g e =
  match e with
  | Let(x, Op(Label ".tuple", ys), e2) ->
      let l = Id.to_string x in
      Hashtbl.add gl_tenv l x.typ;
      let rec iter i = function
        | [] -> ([], g (Alpha.g (M.add x (Label l) M.empty) e2))
        | y::ys -> let lst, e_ = iter (i+1) ys in
          if is_const y then (y :: lst, e_)
          else (y :: lst,
                Let(new_id_t "$" Type.Tunit,
                    Op(Label "t<-", [Label l; Int i; y]), e_))
      in
      let init, e_ = iter 0 ys in
      Hashtbl.add gl_vars l init;
      e_
  | Let(x, Op(Label ".create_array", [Int i; y]), e2) ->
      let l = Id.to_string x in
      Hashtbl.add gl_tenv l x.typ;
      let e_ = g (Alpha.g (M.add x (Label l) M.empty) e2) in
      if is_const y then begin
        Hashtbl.add gl_vars l (list_make i y);
        e_
      end else begin
        Hashtbl.add gl_vars l (list_make i y);
        Let(new_id_t "$" Type.Tunit,
            Op(Label ".fill_array", [Label l; Int i; y]), e_)
      end
  | Let(x, e1, e2) -> Let(x, g e1, g e2)
  | LetRec(f,xs,e1,e2) -> LetRec(f, xs, e1, g e2)
  | Loop(x,ys,zs,e) -> Loop(x,ys,zs, g e)
  | V _ | Op _ | If _ -> e

let f e = g e
