(* よーしパパインライン展開しちゃうぞー *)

open Global
open ILang

let threshold_min = 3 (* サイズがこれ以下の関数はインライン化 *)
let threshold = ref threshold_min
let envl = ref M2.empty

let bonus1 = function Var _ | Unit -> 0 | _ -> 3
let bonus ys =
  List.length ys +
  List.fold_left (fun i y -> i + bonus1 y) 0 ys

let rec is_rec x e =
  match e with
  | V _ -> false
  | Op(y,_) -> x = y
  | If(_,_,_,e1,e2) | Let(_,e1,e2) -> is_rec x e1 || is_rec x e2
  | LetRec(_,_,_,e) | Loop(_,_,_,e) -> is_rec x e

let rec g div env e =
  match e with
  | Op(Label x, ys) when M2.mem x !envl ->
      let (s, zs, body) = M2.find x !envl in
      if s <= max threshold_min ((!threshold + bonus ys) / div)
      then Alpha.g (M.add_list2 zs ys M.empty) body
      else e
  | Op(Var x, ys) when M.mem x env ->
      let (s, zs, body) = M.find x env in
      if s <= max threshold_min ((!threshold + bonus ys) / div)
      then Alpha.g (M.add_list2 zs ys M.empty) body
      else e
  | Let(x,e1,e2) -> Let(x, g div env e1, g div env e2)
  | LetRec(x,ys,e1,e2) ->
      let env_ = M.add x (size e1, ys, e1) env in
      LetRec(x, ys, g 1 env e1, g div env_ e2)
  | If(c,x,y,e1,e2) -> If(c,x,y, g (div*2) env e1, g (div*2) env e2)
  | Loop(x,ys,zs,e) -> Loop(x,ys,zs, g div env e)
  | V _ | Op _ -> e

let f e =
  let sfs = List.map (fun x -> size x.body, x) !gl_funs in
  let sfs = List.fast_sort (fun (x,_) (y,_) -> x - y) sfs in
  gl_funs := List.map snd sfs;
  envl := List.fold_left
      (fun m { name = x; args = ys; body = e } ->
        if is_rec (Label x) e then m else M2.add x (size e, ys, e) m)
      M2.empty !gl_funs;
  gl_funs := List.map
      (fun ({ name = x; args = ys; body = e } as func) ->
        let e_ = g 1 M.empty e in
        if M2.mem x !envl then
          envl := M2.add x (size e_, ys, e_) !envl;
        { func with body = e_ })
      !gl_funs;
  g 1 M.empty e
