(* レジスタ割り当て *)

open TreeAsm

let nouse = H.create 100
let call_graph = H.create 100

let rec sort_aux fs e =
  match e with
  | Forget(_,e) -> sort_aux fs e
  | Ret exp -> sort_aux2 fs exp
  | Let(_,exp,e) ->
      let fs1,fs2 = sort_aux2 fs exp in
      let fs3,fs4 = sort_aux fs2 e in
      (fs1 @ fs3, fs4)
and sort_aux2 fs exp =
  match exp with
  | Call(x,_) -> (try sort fs x with Not_found -> ([], fs))
  | If(_,_,_,e1,e2) | IfI(_,_,_,e1,e2) | FIf(_,_,_,e1,e2) ->
      let fs1,fs2 = sort_sux fs e1 in
      let fs3,fs4 = sort_aux fs2 e2 in
      (fs1 @ fs3, fs4)
  | _ -> ([], fs)
and sort fs x =
  let rec iter = function
  | [] -> raise Not_found
  | hd::tl -> if hd.name = x then hd,tl else let a,b = iter tl in a,hd::b
  in
  let x,fs = iter fs in
  let fs1,fs2 = sort_aux fs x.body in
  x::fs1, fs2

let rec mcg_aux = function
| Forget(_,e) -> mcg_aux e
| Ret exp -> mcg_aux2 exp
| Let(_,exp,e) -> S2.union (mcg_aux2 exp) (mcg_aux e)
and mcg_aux2 = function
| Call(x,_) -> S2.singleton x
| If(_,_,_,e1,e2) | IfI(_,_,_,e1,e2) | FIf(_,_,_,e1,e2) ->
    S2.union (mcg_aux e1) (mcg_aux e2)
| _ -> S2.empty
let make_call_graph { name = x; body = e } =
  H.add call_graph x (mcg_aux e)

let h { name = x; args = ys; body = e } =
  let _,regenv,rs = if S2.mem x !Closure.result then
    List.fold_left
      (fun (i,env,rs) y -> (i+1, (regs.(i),y)::env, regs.(i)::rs))
      0 ys
  else
    List.fold_left
      (fun (i,env,rs) y -> if y = reg_dummy then (i, env, reg_dummy::rs)
       else (i+1, (regs.(i),y)::env, regs.(i)::rs))
      0 ys
  in
  let a = { name = x; args = rs; body = g e; stksiz = 0 } in

  failwith "hoge"

(* プログラム全体のレジスタ割り当て *)
let f fundefs =
  Format.eprintf "register allocation...@.";
  let fundefs,_ = sort fundefs "main" in
  List.iter make_call_graph fundefs;
  let fundefs = List.fold_right (fun x xs -> h x :: xs) fundefs [] in
  H.clear nouse; H.clear call_graph;
  fundefs
