let test0 str = Parser.main Lexer.token (Lexing.from_string str)
let test1 str = Concat.f (test0 str)
let test2 str = ToFlatSyntax.f (test1 str)
let test3 str = Typing.f (test2 str)
let test4 str = ToILang.f (test3 str)
let test5 str = Expansion.f (test4 str)
let test6 str = Englobal.f (test5 str)
let test7 str = Closure.f (test6 str)

let opt1 i str = Opt1.f i (test5 str)
let opt2 i str = Opt2.f i (Closure.f (Englobal.f (opt1 i str)))
let opt3 i str = Opt3.f i (opt2 i str)

let test8 str = ToTreeAsm.f (opt3 10 str)
let test9 str = Opt4.f (test8 str)
let test10 str = RegAlloc.f (test9 str)
let test11 str = StkAlloc.f (test10 str)
let test12 str = ToLinearAsm.f (test11 str)
let test13 str = Peephole.f (test12 str)
let test14 str = Emit.f stdout (test13 str)

let rec pp e =
  match e with
  | ILang.LetRec(x,ys,e1,e2) ->
      if List.mem x Builtin.fun_idents then pp e2
      else ILang.LetRec(x,ys,e1,pp e2)
  | _ -> e

let hash_elements h = Hashtbl.fold (fun k v l -> (k,v)::l) h []

let file x =
  let ic = open_in x in
  let a = Parser.main Lexer.token (Lexing.from_channel ic) in
  close_in ic; a
